package com.luojigou.xiaodou

import android.annotation.SuppressLint
import android.app.Service
import android.content.Intent
import android.os.Binder
import android.os.IBinder
import android.util.ArraySet
import androidx.bluetooth.BluetoothDevice
import androidx.bluetooth.BluetoothLe
import androidx.bluetooth.ScanFilter
import androidx.bluetooth.ScanResult
import com.luojigou.xiaodou.ble.XDScanBLEDevice
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.flow.MutableSharedFlow

@SuppressLint("MissingPermission")
class XDScanBLEService : Service() {
    private val bluetoothLe: BluetoothLe by lazy { BluetoothLe(this) }

    private val deviceSet: MutableSet<XDScanBLEDevice> = ArraySet()

    private val deviceListFlow = MutableSharedFlow<List<XDScanBLEDevice>(listOf())
    override fun onBind(intent: Intent?): IBinder {
        return XDScanBLEBinder(this)
    }

    class XDScanBLEBinder(private val service: XDScanBLEService) : Binder() {
        companion object {
            private val filter: List<ScanFilter> = listOf(
                ScanFilter()
            )
        }

        fun getBluetooth(): BluetoothLe = service.bluetoothLe

        suspend fun scanBle(): Flow<ScanResult> {
            return service.bluetoothLe.scan(filter)
        }

        suspend fun connectGatt(device: BluetoothDevice) {
            service.bluetoothLe.connectGatt(device) {

            }
        }
    }
}