package com.luojigou.xiaodou.ble

import androidx.bluetooth.BluetoothDevice
import androidx.bluetooth.BluetoothLe

sealed class XDScanBLEStatus {
    object Disabled : XDScanBLEStatus()
    object Permission : XDScanBLEStatus()
    object NotSupported : XDScanBLEStatus()
    object Normal : XDScanBLEStatus()

    interface Host {
        fun onStatusChanged(status: XDScanBLEStatus)

        fun getBluetooth(): BluetoothLe

        suspend fun connectBluetooth(device: BluetoothDevice): Boolean
    }
}